name: Dependabot Auto-Merge

on:
  pull_request:
    branches:
      - main

permissions:
  contents: write
  pull-requests: write
  checks: read

jobs:
  dependabot:
    runs-on: ubuntu-latest
    if: >
      github.event.pull_request.user.login == 'dependabot[bot]' &&
      github.repository == 'sw-code/Urbo'
    steps:
      - name: Checkout code
        uses: actions/checkout@v3.5.3
        with:
          fetch-depth: 0

      - name: Dependabot metadata
        id: metadata
        uses: dependabot/fetch-metadata@v1
        with:
          github-token: "${{ secrets.GITHUB_TOKEN }}"

      - name: Check if changes are in urbo-cms/backend
        id: filter
        uses: dorny/paths-filter@v3.0.2
        with:
          filters: |
            backend:
              - 'urbo-cms/backend/**'

      - name: Auto-approve Dependabot PRs
        if: steps.filter.outputs.backend == 'true'
        uses: hmarr/auto-approve-action@v4
        with:
          github-token: "${{ secrets.GITHUB_TOKEN }}"

      - name: Enable auto-merge for Dependabot PRs
        if: steps.filter.outputs.backend == 'true'
        run: gh pr merge --auto --merge "$PR_URL"
        env:
          PR_URL: ${{ github.event.pull_request.html_url }}
          GH_TOKEN: ${{ secrets.GITHUB_TOKEN }}
